# policy creation
# iam readonly access policy for iam users
resource "aws_iam_policy" "iamreadonlyaccess" {
  name        = "iamreadonlyaccess"
  description = "iamreadonlyaccess"
  policy = jsonencode({
    "Version" : "2012-10-17",
    "Statement" : [
      {
        "Sid" : "VisualEditor0",
        "Effect" : "Allow",
        "Action" : [
          "iam:Get*",
          "iam:List*",
        ],
        "Resource" : "*"
      }
    ]
  })
  tags = {
    "createdby" = "terraform"
  }
}

# optional - if you don't generate the pwd from the terraform script comment the below resource
# account password change policy after first login
resource "aws_iam_account_password_policy" "strict" {
  minimum_password_length        = 8
  require_lowercase_characters   = true
  require_uppercase_characters   = true
  require_numbers                = true
  require_symbols                = true
  allow_users_to_change_password = true
}
