# user creation
resource "aws_iam_user" "newusers" {
  count = length(var.usernames)
  name  = element(var.usernames, count.index)
  tags = {
    "createdby" = "terraform"
  }
}

# attaching "iamreadonlyaccess" policy to the user
resource "aws_iam_user_policy_attachment" "usrpolicyrelationship" {
  depends_on = [aws_iam_policy.iamreadonlyaccess]
  count      = length(var.usernames)
  user       = element(aws_iam_user.newusers.*.name, count.index)
  policy_arn = aws_iam_policy.iamreadonlyaccess.arn
}

# optional - if you don't generate the pwd from the terraform script comment the below resource
# generating login password for iam users
resource "aws_iam_user_login_profile" "newusers" {
  count                   = length(var.usernames)
  user                    = element(aws_iam_user.newusers.*.name, count.index)
  password_reset_required = false
  # helps to generate the password
  # output will be shown in the encrypted form
  # reference link - https://stackoverflow.com/questions/53534722/how-to-enable-the-console-login-for-iam-user-in-terraform
  pgp_key = "some_encrypted_base64_encoded_string"
}
